// $Id: Eenadu.js,v 1.1.2.2 2005/06/03 15:57:02 vnagarjuna Exp $ -->

/* ***** BEGIN LICENSE BLOCK ***** 
 * Version: MPL 1.1/GPL 2.0/LGPL 2.1
 *
 * The contents of this file are subject to the Mozilla Public License Version
 * 1.1 (the "License"); you may not use this file except in compliance with
 * the License. You may obtain a copy of the License at
 * http://www.mozilla.org/MPL/
 *
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
 * for the specific language governing rights and limitations under the
 * License.
 *
 * The Initial Developer of the Original Code is Nagarjuna Venna.
 * Portions created by the Initial Developer are Copyright (C) 2005
 * by the Initial Developer. All Rights Reserved.
 *
 * Contributor(s): Nagarjuna Venna <vnagarjuna@yahoo.com>
 *
 * Alternatively, the contents of this file may be used under the terms of
 * either the GNU General Public License Version 2 or later (the "GPL"), or
 * the GNU Lesser General Public License Version 2.1 or later (the "LGPL"),
 * in which case the provisions of the GPL or the LGPL are applicable instead
 * of those above. If you wish to allow use of your version of this file only
 * under the terms of either the GPL or the LGPL, and not to allow others to
 * use your version of this file under the terms of the MPL, indicate your
 * decision by deleting the provisions above and replace them with the notice
 * and other provisions required by the GPL or the LGPL. If you do not delete
 * the provisions above, a recipient may use your version of this file under
 * the terms of any one of the MPL, the GPL or the LGPL.
 *
 * ***** END LICENSE BLOCK ***** */

function Eenadu()
{
}

Eenadu.maxLookupLen = 4;
Eenadu.ctxt_REGULAR = 0;
Eenadu.ctxt_HA      = 1;

//Specials
Eenadu.candrabindu    = "\u00D2";
Eenadu.visarga        = "\u00D3";
Eenadu.virama_1       = "\u0072";
Eenadu.virama_2       = "\u00FA";
Eenadu.virama_3       = "\u00FB";
Eenadu.virama_4       = "\u00FC";               //Y
Eenadu.virama_5       = "\u00FD";               //Y
Eenadu.virama_6       = "\u00FE";               //Y
Eenadu.anusvara       = "\u00A2";               //Y

//Vowels
Eenadu.vowel_A_1      = "\u20AC";               //Y
Eenadu.vowel_A_2      = "\u00C6";               //Y
Eenadu.vowel_AA       = "\u201A";               //Y - 82
Eenadu.vowel_I        = "\u0192";               //Y - 83 
Eenadu.vowel_II       = "\u00A8";               //Y
Eenadu.vowel_U        = "\u2026";               //Y - 85
Eenadu.vowel_UU       = "\u00AD";
Eenadu.vowel_E        = "\u2021";               //Y - 87
Eenadu.vowel_EE       = "\u005C";               //Y
Eenadu.vowel_AI       = "\u2030";               //Y - 89
Eenadu.vowel_O        = "\u0160";               //  - 8A
Eenadu.vowel_OO       = "\u2039";               //  - 8B
Eenadu.vowel_AU       = "\u00BB";

//Consonants
Eenadu.consnt_KA_1    = "\u008F";
Eenadu.consnt_KA_2    = "\u00C2";               //Y
Eenadu.consnt_KHA_1   = "\u2018";               //  - 91
Eenadu.consnt_KHA_2   = "\u00C8";               //Y
Eenadu.consnt_GA      = "\u2019";               //Y - 92
Eenadu.consnt_GHA     = "\u0058\u00B6\u00D5";   //Y - 
Eenadu.consnt_NGA     = "\u0076";

Eenadu.consnt_CA      = "\u00CD";               //Y
Eenadu.consnt_CHA     = "\u00CD\u00B5";         //Y
Eenadu.consnt_JA_1    = "\u2022";               //Y - 95
Eenadu.consnt_JA_2    = "\u00E8";               //Y
Eenadu.consnt_JHA     = "\u2014";               //  - 97
Eenadu.consnt_NYA     = "\u203A";               //  - 9B

Eenadu.consnt_TTA_1   = "\u007B";               //Y
Eenadu.consnt_TTA_2   = "\u02DC";               //Y - 98 
Eenadu.consnt_TTA_3   = "\u0161";               //Y - 9A
Eenadu.consnt_TTHA    = "\u00AA\u00B8";         //Y
Eenadu.consnt_DDA     = "\u0153";               //Y - 9C
Eenadu.consnt_DDHA    = "\u0153\u00B5";         //Y
Eenadu.consnt_NNA     = "\u00BA";               //Y

Eenadu.consnt_TA      = "\u00C5";               //Y
Eenadu.consnt_DA      = "\u0178";               //Y - 9F
Eenadu.consnt_DHA_1   = "\u0178\u00B5";         //Y
Eenadu.consnt_DHA_2   = "\u0178\u00B1";         //Y
Eenadu.consnt_NA_1    = "\u00A0";
Eenadu.consnt_NA_2    = "\u00CA";               //Y
Eenadu.consnt_NA_3    = "\u00AF";               //Y

Eenadu.consnt_PA_1    = "\u0058";               //Y
Eenadu.consnt_PA_2    = "\u00A4";               //Y
Eenadu.consnt_PHA_1   = "\u0058\u00B6";         //Y
Eenadu.consnt_PHA_2   = "\u00A4\u00B6";         //Y
Eenadu.consnt_BA_1    = "\u00A6";               //Y
Eenadu.consnt_BA_2    = "\u00FF";
Eenadu.consnt_BHA     = "\u00A6\u00B5";         //Y
Eenadu.consnt_MA      = "\u00AB\u00D5";         //Y

Eenadu.consnt_YA_1    = "\u00A7";               //Y 
Eenadu.consnt_YA_2    = "\u00A7\u00D5";         //Y 
Eenadu.consnt_RA      = "\u00AA";               //Y
Eenadu.consnt_LA_1    = "\u2122";               //  - 99
Eenadu.consnt_LA_2    = "\u00A9";               //Y
Eenadu.consnt_VA_1    = "\u201E";               //Y - 84  
Eenadu.consnt_VA_2    = "\u00AB";               //Y
Eenadu.consnt_SHA     = "\u00AC";               //Y
Eenadu.consnt_SSA_1   = "\u2020";               //Y - 86
Eenadu.consnt_SSA_2   = "\u00B3";               //Y
Eenadu.consnt_SA_1    = "\u00AE";               //Y
Eenadu.consnt_SA_2    = "\u00B2";               //Y
Eenadu.consnt_HA      = "\u00A3";               //Y 
Eenadu.consnt_LLA     = "\u0040";               //Y
Eenadu.consnt_RRA     = "\u00B7";
Eenadu.consnt_KSHA    = "\u00C2\u007E";         //Y

//Gunintamulu
Eenadu.vowelsn_AA_1   = "\u00C3";               //Y
Eenadu.vowelsn_AA_2   = "\u00C4";               //Y 
Eenadu.vowelsn_AA_3   = "\u00C7";               //Y
Eenadu.vowelsn_AA_4   = "\u00C9";
Eenadu.vowelsn_I_1    = "\u00CB";               //Y
Eenadu.vowelsn_I_2    = "\u00CF";               //Y
Eenadu.vowelsn_II_1   = "\u00CC";               //Y
Eenadu.vowelsn_II_2   = "\u00CE";
Eenadu.vowelsn_II_3   = "\u00D4";               //Y
Eenadu.vowelsn_U_1    = "\u00D5";               //Y
Eenadu.vowelsn_U_2    = "\u00D7";               //Y
Eenadu.vowelsn_U_3    = "\u00D9";
Eenadu.vowelsn_U_4    = "\u00DB";               //Y
Eenadu.vowelsn_U_5    = "\u00DD";
Eenadu.vowelsn_U_6    = "\u00DF";               //Y
Eenadu.vowelsn_U_7    = "\u00E1";               //Y
Eenadu.vowelsn_UU_1   = "\u00D6";               //Y
Eenadu.vowelsn_UU_2   = "\u00D8";
Eenadu.vowelsn_UU_3   = "\u00DA";
Eenadu.vowelsn_UU_4   = "\u00DC";
Eenadu.vowelsn_UU_5   = "\u00DE";
Eenadu.vowelsn_UU_6   = "\u00E0";
Eenadu.vowelsn_UU_7   = "\u00E2";
Eenadu.vowelsn_R      = "\u0025";               //Y
Eenadu.vowelsn_E_1    = "\u00E3";               //Y
Eenadu.vowelsn_E_2    = "\u00E5";               //Y
Eenadu.vowelsn_E_3    = "\u00E7";               //Y
Eenadu.vowelsn_E_4    = "\u00E9";               //Y
Eenadu.vowelsn_E_5    = "\u00EB";
Eenadu.vowelsn_EE_1   = "\u00E4";               //Y
Eenadu.vowelsn_EE_2   = "\u00E6";               //Y
Eenadu.vowelsn_EE_3   = "\u00EA";               //Y
Eenadu.vowelsn_EE_4   = "\u00EC";               //Y
Eenadu.vowelsn_O_1    = "\u00ED";               //Y
Eenadu.vowelsn_O_2    = "\u00EF";               //Y
Eenadu.vowelsn_O_3    = "\u00F1";
Eenadu.vowelsn_O_4    = "\u00F3";
Eenadu.vowelsn_OO_1   = "\u00EE";               //Y
Eenadu.vowelsn_OO_2   = "\u00F0";               //Y
Eenadu.vowelsn_OO_3   = "\u00F2";               //Y
Eenadu.vowelsn_OO_4   = "\u00F4";
Eenadu.vowelsn_OO_5   = "\u00E3\u00D6";         //Y
Eenadu.vowelsn_AU_1   = "\u00F5";
Eenadu.vowelsn_AU_2   = "\u00F6";
Eenadu.vowelsn_AU_3   = "\u00F7";
Eenadu.vowelsn_AU_4   = "\u00F8";
Eenadu.vowelsn_AU_5   = "\u00F9";               //Y

Eenadu.vowelsn_AILEN_1 = "\u0069";              //Y
Eenadu.vowelsn_AILEN_2 = "\u006A";              //Y

//Special Combinations
Eenadu.combo_KHI      = "\u0022";
Eenadu.combo_KHII     = "\u0026";
Eenadu.combo_GI       = "\u0054";
Eenadu.combo_GII      = "\u0055";
Eenadu.combo_GHAA     = "\u0058\u00B6\u00D6";   //Y
Eenadu.combo_GHI      = "\u0058\u00B6\u00CF\u00D5"; //Y

Eenadu.combo_CI       = "\u002A";
Eenadu.combo_CII      = "\u003C";
Eenadu.combo_JI       = "\u003E";
Eenadu.combo_JII      = "\u00B0";               //Y
Eenadu.combo_JU       = "\u0056";
Eenadu.combo_JUU      = "\u0057";               //Y

Eenadu.combo_TI       = "\u0041";               //Y
Eenadu.combo_TII      = "\u0042";
Eenadu.combo_DI       = "\u0043";               //Y
Eenadu.combo_DII      = "\u0044";               //Y
Eenadu.combo_DHI_1    = "\u0043\u00B1";         //Y
Eenadu.combo_DHI_2    = "\u0043\u00B5";         //Y
Eenadu.combo_DHII     = "\u0044\u00B5";         //Y
Eenadu.combo_NI       = "\u0045";               //Y
Eenadu.combo_NII      = "\u0046";

Eenadu.combo_BI       = "\u0047";               //Y
Eenadu.combo_BII      = "\u0048";
Eenadu.combo_BHI      = "\u0047\u00B5";         //Y
Eenadu.combo_BHII     = "\u0048\u00B5";         //Y
Eenadu.combo_MAA      = "\u00AB\u00D6";         //Y
Eenadu.combo_MI       = "\u004E\u00D5";         //Y
Eenadu.combo_MII      = "\u004F\u00D5";         //Y
Eenadu.combo_MU       = "\u00AB\u00E1";         //Y
Eenadu.combo_MUU      = "\u00AB\u00E2";         //Y
Eenadu.combo_ME_1     = "\u201E\u00E3\u00D5";   //Y
Eenadu.combo_ME_2     = "\u201E\u00E7\u00D5";   //Y
Eenadu.combo_MEE      = "\u201E\u00E4\u00D5";   //Y
Eenadu.combo_MAI      = "\u201E\u00E7\u00D5\u0069";   //Y
Eenadu.combo_MO       = "\u201E\u00E7\u00E1";   //Y
Eenadu.combo_MOO      = "\u201E\u00E7\u00D6";   //Y
Eenadu.combo_MPOLLU   = "\u201E\u00FE\u00D5";   //Y

Eenadu.combo_YAA      = "\u00A7\u00D6";         //Y
Eenadu.combo_YI       = "\u00AA\u00E1";         //Y
Eenadu.combo_YE       = "\u00A7\u00E7\u00D5";   //Y
Eenadu.combo_YEE      = "\u00A7\u00E4\u00D5";   //Y
Eenadu.combo_YO       = "\u00A7\u00E7\u00E1";   //Y
Eenadu.combo_YOO      = "\u00A7\u00E7\u00D6";   //Y
Eenadu.combo_YPOLLU_1 = "\u00A7\u00FC\u00D5";   //Y
Eenadu.combo_YPOLLU_2 = "\u00A7\u00FD\u00D5";   //Y
Eenadu.combo_RI       = "\u004A";               //Y
Eenadu.combo_RII      = "\u004B";               //Y
Eenadu.combo_LI       = "\u004C";               //Y
Eenadu.combo_LII      = "\u004D";               //Y
Eenadu.combo_VI       = "\u004E";               //Y 
Eenadu.combo_VII      = "\u004F";               //Y
Eenadu.combo_SHI      = "\u0050";
Eenadu.combo_SHII     = "\u0051";               //Y
Eenadu.combo_LLI      = "\u0052";
Eenadu.combo_LLII     = "\u0053";               //Y

Eenadu.combo_SHRII    = "\u00A1";

//Vattulu
Eenadu.vattu_KA       = "\u02C6";               //Y - 88
Eenadu.vattu_KHA      = "\u005E";
Eenadu.vattu_GA       = "\u005F";               //Y
Eenadu.vattu_GHA      = "\u0060";

Eenadu.vattu_CA_1     = "\u0061";               //Y
Eenadu.vattu_CA_2     = "\u0061\u00B4";         //Y
Eenadu.vattu_JA       = "\u0062";               //Y
Eenadu.vattu_JHA      = "\u006D";
Eenadu.vattu_NYA      = "\u0063";               //Y

Eenadu.vattu_TTA      = "\u0064";               //Y
Eenadu.vattu_TTHA     = "\u0065";               //Y
Eenadu.vattu_DDA      = "\u0066";               //Y
Eenadu.vattu_NNA      = "\u0067";               //Y

Eenadu.vattu_TA_1     = "\u0068";               //Y
Eenadu.vattu_TA_2     = "\u006B";
Eenadu.vattu_THA      = "\u006E";
Eenadu.vattu_DA       = "\u006C";               //Y
Eenadu.vattu_DHA      = "\u006C\u00B4";         //Y
Eenadu.vattu_NA       = "\u006F";               //Y

Eenadu.vattu_PA       = "\u0070";               //Y
Eenadu.vattu_PHA      = "\u0070\u00B4";         //Y
Eenadu.vattu_BA       = "\u0073";               //Y
Eenadu.vattu_BHA      = "\u0073\u00B4";         //Y 
Eenadu.vattu_MA       = "\u0074";               //Y

Eenadu.vattu_YA       = "\u0075";               //Y
Eenadu.vattu_RA_1     = "\u0077";               //Y
Eenadu.vattu_RA_2     = "\u201C";               //Y - 93
Eenadu.vattu_LA       = "\u0078";               //Y
Eenadu.vattu_VA       = "\u0079";               //Y
Eenadu.vattu_SHA      = "\u007A";               //Y
Eenadu.vattu_SSA_1    = "\u007E";               //Y
Eenadu.vattu_SSA_2    = "\u00A5";
Eenadu.vattu_SA       = "\u0071";               //Y
Eenadu.vattu_HA       = "\u007C";
Eenadu.vattu_LLA      = "\u007D";
Eenadu.vattu_RRA      = "\u00C0";

//Conjuncts
Eenadu.vattu_TRA      = "\u0059";               //Y
Eenadu.vattu_TTRA     = "\u005A";               //Y

//Matches ASCII
Eenadu.EXCLAM         = "\u0021";
Eenadu.QTSINGLE       = "\u0027";
Eenadu.PARENLEFT      = "\u0028";
Eenadu.PARENRIGT      = "\u0029";
Eenadu.PLUS           = "\u002B";
Eenadu.COMMA          = "\u002C";
Eenadu.HYPHEN         = "\u002D";   //I don't know what the significance is, shows up as '-' on Linux, not displayed on Windows in Firefox
Eenadu.PERIOD         = "\u002E";
Eenadu.SLASH          = "\u002F";
Eenadu.COLON          = "\u003A";
Eenadu.SEMICOLON      = "\u003B";
Eenadu.EQUALS         = "\u003D";
Eenadu.QUESTION       = "\u003F";

Eenadu.digit_ZERO     = "\u0030";
Eenadu.digit_ONE      = "\u0031";
Eenadu.digit_TWO      = "\u0032";
Eenadu.digit_THREE    = "\u0033";
Eenadu.digit_FOUR     = "\u0034";
Eenadu.digit_FIVE     = "\u0035";
Eenadu.digit_SIX      = "\u0036";
Eenadu.digit_SEVEN    = "\u0037";
Eenadu.digit_EIGHT    = "\u0038";
Eenadu.digit_NINE     = "\u0039";

//Does not match ASCII
Eenadu.DIVIDE         = "\u0023";
Eenadu.MULTIPLY       = "\u0024";
Eenadu.PIPE           = "\u0049";
Eenadu.ASTERISK       = "\u005B";
Eenadu.PERCENT        = "\u005D";

//Kommu
Eenadu.misc_TICK_1    = "\u0152";               //Y - 8C
Eenadu.misc_TICK_2    = "\u00B9";               //Y
Eenadu.misc_TICK_3    = "\u00BC";               //Y
Eenadu.misc_TICK_4    = "\u00BD";               //Y
Eenadu.misc_TICK_5    = "\u00BE";               //Y
Eenadu.misc_TICK_6    = "\u00BF";               //Y
Eenadu.misc_TICK_7    = "\u00C1";

Eenadu.misc_vattu_1   = "\u00B4";               //This seems to be for vattulu
Eenadu.misc_vattu_2   = "\u00B5";               //This seems to be for consonants
Eenadu.misc_vattu_3   = "\u00B6";               //Gha, pha etc

Eenadu.extra_HYPHEN   = "\u00D0";
Eenadu.extra_QTSINGLE = "\u00D1";

Eenadu.toPadma = new Array();

Eenadu.toPadma[Eenadu.candrabindu] = Padma.candrabindu;
Eenadu.toPadma[Eenadu.visarga]  = Padma.visarga;
Eenadu.toPadma[Eenadu.virama_1] = Padma.pollu;
Eenadu.toPadma[Eenadu.virama_2] = Padma.pollu;
Eenadu.toPadma[Eenadu.virama_3] = Padma.pollu;
Eenadu.toPadma[Eenadu.virama_4] = Padma.pollu;
Eenadu.toPadma[Eenadu.virama_5] = Padma.pollu;
Eenadu.toPadma[Eenadu.virama_6] = Padma.pollu;
Eenadu.toPadma[Eenadu.anusvara] = Padma.anusvara;

Eenadu.toPadma[Eenadu.vowel_A_1] = Padma.vowel_A;
Eenadu.toPadma[Eenadu.vowel_A_2] = Padma.vowel_A;
Eenadu.toPadma[Eenadu.vowel_AA] = Padma.vowel_AA;
Eenadu.toPadma[Eenadu.vowel_I] = Padma.vowel_I;
Eenadu.toPadma[Eenadu.vowel_II] = Padma.vowel_II;
Eenadu.toPadma[Eenadu.vowel_U] = Padma.vowel_U;
Eenadu.toPadma[Eenadu.vowel_UU] = Padma.vowel_UU;
Eenadu.toPadma[Eenadu.vowel_E] = Padma.vowel_E;
Eenadu.toPadma[Eenadu.vowel_EE] = Padma.vowel_EE;
Eenadu.toPadma[Eenadu.vowel_AI] = Padma.vowel_AI;
Eenadu.toPadma[Eenadu.vowel_O] = Padma.vowel_O;
Eenadu.toPadma[Eenadu.vowel_OO] = Padma.vowel_OO;
Eenadu.toPadma[Eenadu.vowel_AU] = Padma.vowel_AU;

Eenadu.toPadma[Eenadu.consnt_KA_1] = Padma.consnt_KA;
Eenadu.toPadma[Eenadu.consnt_KA_2] = Padma.consnt_KA;
Eenadu.toPadma[Eenadu.consnt_KHA_1] = Padma.consnt_KHA;
Eenadu.toPadma[Eenadu.consnt_KHA_2] = Padma.consnt_KHA;
Eenadu.toPadma[Eenadu.consnt_GA] = Padma.consnt_GA;
Eenadu.toPadma[Eenadu.consnt_GHA] = Padma.consnt_GHA;
Eenadu.toPadma[Eenadu.consnt_NGA] = Padma.consnt_NGA;

Eenadu.toPadma[Eenadu.consnt_CA] = Padma.consnt_CA;
Eenadu.toPadma[Eenadu.consnt_CHA] = Padma.consnt_CHA;
Eenadu.toPadma[Eenadu.consnt_JA_1] = Padma.consnt_JA;
Eenadu.toPadma[Eenadu.consnt_JA_2] = Padma.consnt_JA;
Eenadu.toPadma[Eenadu.consnt_JHA] = Padma.consnt_JHA;
Eenadu.toPadma[Eenadu.consnt_NYA] = Padma.consnt_NYA;

Eenadu.toPadma[Eenadu.consnt_TTA_1] = Padma.consnt_TTA;
Eenadu.toPadma[Eenadu.consnt_TTA_2] = Padma.consnt_TTA;
Eenadu.toPadma[Eenadu.consnt_TTA_3] = Padma.consnt_TTA;
Eenadu.toPadma[Eenadu.consnt_TTHA] = Padma.consnt_TTHA;
Eenadu.toPadma[Eenadu.consnt_DDA] = Padma.consnt_DDA;
Eenadu.toPadma[Eenadu.consnt_DDHA] = Padma.consnt_DDHA;
Eenadu.toPadma[Eenadu.consnt_NNA] = Padma.consnt_NNA;

Eenadu.toPadma[Eenadu.consnt_TA] = Padma.consnt_TA;
Eenadu.toPadma[Eenadu.consnt_THA] = Padma.consnt_THA;
Eenadu.toPadma[Eenadu.consnt_DA] = Padma.consnt_DA;
Eenadu.toPadma[Eenadu.consnt_DHA_1] = Padma.consnt_DHA;
Eenadu.toPadma[Eenadu.consnt_DHA_2] = Padma.consnt_DHA;
Eenadu.toPadma[Eenadu.consnt_NA_1] = Padma.consnt_NA;
Eenadu.toPadma[Eenadu.consnt_NA_2] = Padma.consnt_NA;
Eenadu.toPadma[Eenadu.consnt_NA_3] = Padma.consnt_NA;

Eenadu.toPadma[Eenadu.consnt_PA_1] = Padma.consnt_PA;
Eenadu.toPadma[Eenadu.consnt_PA_2] = Padma.consnt_PA;
Eenadu.toPadma[Eenadu.consnt_PHA_1]  = Padma.consnt_PHA;
Eenadu.toPadma[Eenadu.consnt_PHA_2]  = Padma.consnt_PHA;
Eenadu.toPadma[Eenadu.consnt_BA_1] = Padma.consnt_BA;
Eenadu.toPadma[Eenadu.consnt_BA_2] = Padma.consnt_BA;
Eenadu.toPadma[Eenadu.consnt_BHA]  = Padma.consnt_BHA;
Eenadu.toPadma[Eenadu.consnt_MA] = Padma.consnt_MA;

Eenadu.toPadma[Eenadu.consnt_YA_1] = Padma.consnt_YA;
Eenadu.toPadma[Eenadu.consnt_YA_2] = Padma.consnt_YA;
Eenadu.toPadma[Eenadu.consnt_RA] = Padma.consnt_RA;
Eenadu.toPadma[Eenadu.consnt_LA_1] = Padma.consnt_LA;
Eenadu.toPadma[Eenadu.consnt_LA_2] = Padma.consnt_LA;
Eenadu.toPadma[Eenadu.consnt_VA_1] = Padma.consnt_VA;
Eenadu.toPadma[Eenadu.consnt_VA_2] = Padma.consnt_VA;
Eenadu.toPadma[Eenadu.consnt_SHA] = Padma.consnt_SHA;
Eenadu.toPadma[Eenadu.consnt_SSA_1] = Padma.consnt_SSA;
Eenadu.toPadma[Eenadu.consnt_SSA_2] = Padma.consnt_SSA;
Eenadu.toPadma[Eenadu.consnt_SA_1] = Padma.consnt_SA;
Eenadu.toPadma[Eenadu.consnt_SA_2] = Padma.consnt_SA;

Eenadu.toPadma[Eenadu.consnt_HA] = Padma.consnt_HA;
Eenadu.toPadma[Eenadu.consnt_LLA] = Padma.consnt_LLA;
Eenadu.toPadma[Eenadu.consnt_RRA] = Padma.consnt_RRA;
Eenadu.toPadma[Eenadu.consnt_KSHA] = Padma.consnt_KSH;


//Gunintamulu
Eenadu.toPadma[Eenadu.vowelsn_AA_1]  = Padma.vowelsn_AA;
Eenadu.toPadma[Eenadu.vowelsn_AA_2]  = Padma.vowelsn_AA;
Eenadu.toPadma[Eenadu.vowelsn_AA_3]  = Padma.vowelsn_AA;
Eenadu.toPadma[Eenadu.vowelsn_AA_4]  = Padma.vowelsn_AA;
Eenadu.toPadma[Eenadu.vowelsn_I_1]   = Padma.vowelsn_I;
Eenadu.toPadma[Eenadu.vowelsn_I_2]   = Padma.vowelsn_I;
Eenadu.toPadma[Eenadu.vowelsn_II_1]  = Padma.vowelsn_II;
Eenadu.toPadma[Eenadu.vowelsn_II_2]  = Padma.vowelsn_II;
Eenadu.toPadma[Eenadu.vowelsn_II_3]  = Padma.vowelsn_II;
Eenadu.toPadma[Eenadu.vowelsn_U_1]   = Padma.vowelsn_U;
Eenadu.toPadma[Eenadu.vowelsn_U_2]   = Padma.vowelsn_U;
Eenadu.toPadma[Eenadu.vowelsn_U_3]   = Padma.vowelsn_U;
Eenadu.toPadma[Eenadu.vowelsn_U_4]   = Padma.vowelsn_U;
Eenadu.toPadma[Eenadu.vowelsn_U_5]   = Padma.vowelsn_U;
Eenadu.toPadma[Eenadu.vowelsn_U_6]   = Padma.vowelsn_U;
Eenadu.toPadma[Eenadu.vowelsn_U_7]   = Padma.vowelsn_U;
Eenadu.toPadma[Eenadu.vowelsn_UU_1]  = Padma.vowelsn_UU;
Eenadu.toPadma[Eenadu.vowelsn_UU_2]  = Padma.vowelsn_UU;
Eenadu.toPadma[Eenadu.vowelsn_UU_3]  = Padma.vowelsn_UU;
Eenadu.toPadma[Eenadu.vowelsn_UU_4]  = Padma.vowelsn_UU;
Eenadu.toPadma[Eenadu.vowelsn_UU_5]  = Padma.vowelsn_UU;
Eenadu.toPadma[Eenadu.vowelsn_UU_6]  = Padma.vowelsn_UU;
Eenadu.toPadma[Eenadu.vowelsn_UU_7]  = Padma.vowelsn_UU;
Eenadu.toPadma[Eenadu.vowelsn_R]     = Padma.vowelsn_R;
Eenadu.toPadma[Eenadu.vowelsn_E_1]   = Padma.vowelsn_E;
Eenadu.toPadma[Eenadu.vowelsn_E_2]   = Padma.vowelsn_E;
Eenadu.toPadma[Eenadu.vowelsn_E_3]   = Padma.vowelsn_E;
Eenadu.toPadma[Eenadu.vowelsn_E_4]   = Padma.vowelsn_E;
Eenadu.toPadma[Eenadu.vowelsn_E_5]   = Padma.vowelsn_E;
Eenadu.toPadma[Eenadu.vowelsn_EE_1]  = Padma.vowelsn_EE;
Eenadu.toPadma[Eenadu.vowelsn_EE_2]  = Padma.vowelsn_EE;
Eenadu.toPadma[Eenadu.vowelsn_EE_3]  = Padma.vowelsn_EE;
Eenadu.toPadma[Eenadu.vowelsn_EE_4]  = Padma.vowelsn_EE;
Eenadu.toPadma[Eenadu.vowelsn_O_1]   = Padma.vowelsn_O;
Eenadu.toPadma[Eenadu.vowelsn_O_2]   = Padma.vowelsn_O;
Eenadu.toPadma[Eenadu.vowelsn_O_3]   = Padma.vowelsn_O;
Eenadu.toPadma[Eenadu.vowelsn_O_4]   = Padma.vowelsn_O;
Eenadu.toPadma[Eenadu.vowelsn_OO_1]  = Padma.vowelsn_OO;
Eenadu.toPadma[Eenadu.vowelsn_OO_2]  = Padma.vowelsn_OO;
Eenadu.toPadma[Eenadu.vowelsn_OO_3]  = Padma.vowelsn_OO;
Eenadu.toPadma[Eenadu.vowelsn_OO_4]  = Padma.vowelsn_OO;
Eenadu.toPadma[Eenadu.vowelsn_OO_5]  = Padma.vowelsn_OO;
Eenadu.toPadma[Eenadu.vowelsn_AU_1]  = Padma.vowelsn_AU;
Eenadu.toPadma[Eenadu.vowelsn_AU_2]  = Padma.vowelsn_AU;
Eenadu.toPadma[Eenadu.vowelsn_AU_3]  = Padma.vowelsn_AU;
Eenadu.toPadma[Eenadu.vowelsn_AU_4]  = Padma.vowelsn_AU;
Eenadu.toPadma[Eenadu.vowelsn_AU_5]  = Padma.vowelsn_AU;
Eenadu.toPadma[Eenadu.vowelsn_AILEN_1] = Padma.vowelsn_AILEN;
Eenadu.toPadma[Eenadu.vowelsn_AILEN_2] = Padma.vowelsn_AILEN;

//Special Combinations
Eenadu.toPadma[Eenadu.combo_KHI]     = Padma.consnt_KHA + Padma.vowelsn_I;
Eenadu.toPadma[Eenadu.combo_KHII]    = Padma.consnt_KHA + Padma.vowelsn_II;
Eenadu.toPadma[Eenadu.combo_GI]      = Padma.consnt_GA + Padma.vowelsn_I;
Eenadu.toPadma[Eenadu.combo_GII]     = Padma.consnt_GA + Padma.vowelsn_II;
Eenadu.toPadma[Eenadu.combo_GHAA]    = Padma.consnt_GHA + Padma.vowelsn_AA;
Eenadu.toPadma[Eenadu.combo_GHI]     = Padma.consnt_GHA + Padma.vowelsn_I;

Eenadu.toPadma[Eenadu.combo_CI]      = Padma.consnt_CA + Padma.vowelsn_I;
Eenadu.toPadma[Eenadu.combo_CII]     = Padma.consnt_CA + Padma.vowelsn_II;
Eenadu.toPadma[Eenadu.combo_JI]      = Padma.consnt_JA + Padma.vowelsn_I;
Eenadu.toPadma[Eenadu.combo_JII]     = Padma.consnt_JA + Padma.vowelsn_II;
Eenadu.toPadma[Eenadu.combo_JU]      = Padma.consnt_JA + Padma.vowelsn_U;
Eenadu.toPadma[Eenadu.combo_JUU]     = Padma.consnt_JA + Padma.vowelsn_UU;

Eenadu.toPadma[Eenadu.combo_TI]      = Padma.consnt_TA + Padma.vowelsn_I;
Eenadu.toPadma[Eenadu.combo_TII]     = Padma.consnt_TA + Padma.vowelsn_II;
Eenadu.toPadma[Eenadu.combo_DI]      = Padma.consnt_DA + Padma.vowelsn_I;
Eenadu.toPadma[Eenadu.combo_DII]     = Padma.consnt_DA + Padma.vowelsn_II;
Eenadu.toPadma[Eenadu.combo_DHI_1]   = Padma.consnt_DHA + Padma.vowelsn_I;
Eenadu.toPadma[Eenadu.combo_DHI_2]   = Padma.consnt_DHA + Padma.vowelsn_I;
Eenadu.toPadma[Eenadu.combo_DHII]    = Padma.consnt_DHA + Padma.vowelsn_II;
Eenadu.toPadma[Eenadu.combo_NI]      = Padma.consnt_NA + Padma.vowelsn_I;
Eenadu.toPadma[Eenadu.combo_NII]     = Padma.consnt_NA + Padma.vowelsn_II;

Eenadu.toPadma[Eenadu.combo_BI]      = Padma.consnt_BA + Padma.vowelsn_I;
Eenadu.toPadma[Eenadu.combo_BII]     = Padma.consnt_BA + Padma.vowelsn_II;
Eenadu.toPadma[Eenadu.combo_BHI]     = Padma.consnt_BHA + Padma.vowelsn_I;
Eenadu.toPadma[Eenadu.combo_BHII]    = Padma.consnt_BHA + Padma.vowelsn_II;
Eenadu.toPadma[Eenadu.combo_MAA]     = Padma.consnt_MA + Padma.vowelsn_AA;
Eenadu.toPadma[Eenadu.combo_MI]      = Padma.consnt_MA + Padma.vowelsn_I;
Eenadu.toPadma[Eenadu.combo_MII]     = Padma.consnt_MA + Padma.vowelsn_II;
Eenadu.toPadma[Eenadu.combo_MU]      = Padma.consnt_MA + Padma.vowelsn_U;
Eenadu.toPadma[Eenadu.combo_MUU]     = Padma.consnt_MA + Padma.vowelsn_UU;
Eenadu.toPadma[Eenadu.combo_ME_1]    = Padma.consnt_MA + Padma.vowelsn_E;
Eenadu.toPadma[Eenadu.combo_ME_2]    = Padma.consnt_MA + Padma.vowelsn_E;
Eenadu.toPadma[Eenadu.combo_MEE]     = Padma.consnt_MA + Padma.vowelsn_EE;
Eenadu.toPadma[Eenadu.combo_MAI]     = Padma.consnt_MA + Padma.vowelsn_AI;
Eenadu.toPadma[Eenadu.combo_MO]      = Padma.consnt_MA + Padma.vowelsn_O;
Eenadu.toPadma[Eenadu.combo_MOO]     = Padma.consnt_MA + Padma.vowelsn_OO;
Eenadu.toPadma[Eenadu.combo_MPOLLU]  = Padma.consnt_MA + Padma.pollu;

Eenadu.toPadma[Eenadu.combo_YAA]     = Padma.consnt_YA + Padma.vowelsn_AA;
Eenadu.toPadma[Eenadu.combo_YI]      = Padma.consnt_YA + Padma.vowelsn_I;
Eenadu.toPadma[Eenadu.combo_YE]      = Padma.consnt_YA + Padma.vowelsn_E;
Eenadu.toPadma[Eenadu.combo_YEE]     = Padma.consnt_YA + Padma.vowelsn_EE;
Eenadu.toPadma[Eenadu.combo_YO]      = Padma.consnt_YA + Padma.vowelsn_O;
Eenadu.toPadma[Eenadu.combo_YOO]     = Padma.consnt_YA + Padma.vowelsn_OO;
Eenadu.toPadma[Eenadu.combo_YPOLLU_1]= Padma.consnt_YA + Padma.pollu;
Eenadu.toPadma[Eenadu.combo_YPOLLU_2]= Padma.consnt_YA + Padma.pollu;
Eenadu.toPadma[Eenadu.combo_RI]      = Padma.consnt_RA + Padma.vowelsn_I;
Eenadu.toPadma[Eenadu.combo_RII]     = Padma.consnt_RA + Padma.vowelsn_II;
Eenadu.toPadma[Eenadu.combo_LI]      = Padma.consnt_LA + Padma.vowelsn_I;
Eenadu.toPadma[Eenadu.combo_LII]     = Padma.consnt_LA + Padma.vowelsn_II;
Eenadu.toPadma[Eenadu.combo_VI]      = Padma.consnt_VA + Padma.vowelsn_I;
Eenadu.toPadma[Eenadu.combo_VII]     = Padma.consnt_VA + Padma.vowelsn_II;
Eenadu.toPadma[Eenadu.combo_SHI]     = Padma.consnt_SHA + Padma.vowelsn_I;
Eenadu.toPadma[Eenadu.combo_SHII]    = Padma.consnt_SHA + Padma.vowelsn_II;
Eenadu.toPadma[Eenadu.combo_LLI]     = Padma.consnt_LLA + Padma.vowelsn_I;
Eenadu.toPadma[Eenadu.combo_LLII]    = Padma.consnt_LLA + Padma.vowelsn_II;

Eenadu.toPadma[Eenadu.combo_SHRII]   = Padma.consnt_SHA + Padma.vattu_RA + Padma.vowelsn_II;

//Vattulu
Eenadu.toPadma[Eenadu.vattu_KA]      = Padma.vattu_KA;
Eenadu.toPadma[Eenadu.vattu_KHA]     = Padma.vattu_KHA;
Eenadu.toPadma[Eenadu.vattu_GA]      = Padma.vattu_GA;
Eenadu.toPadma[Eenadu.vattu_GHA]     = Padma.vattu_GHA;
Eenadu.toPadma[Eenadu.vattu_CA_1]    = Padma.vattu_CA;
Eenadu.toPadma[Eenadu.vattu_CA_2]    = Padma.vattu_CA;
Eenadu.toPadma[Eenadu.vattu_JA]      = Padma.vattu_JA;
Eenadu.toPadma[Eenadu.vattu_JHA]     = Padma.vattu_JHA;
Eenadu.toPadma[Eenadu.vattu_NYA]     = Padma.vattu_NYA;
Eenadu.toPadma[Eenadu.vattu_TTA]     = Padma.vattu_TTA;
Eenadu.toPadma[Eenadu.vattu_TTHA]    = Padma.vattu_TTHA;
Eenadu.toPadma[Eenadu.vattu_DDA]     = Padma.vattu_DDA;
Eenadu.toPadma[Eenadu.vattu_NNA]     = Padma.vattu_NNA;
Eenadu.toPadma[Eenadu.vattu_TA_1]    = Padma.vattu_TA;
Eenadu.toPadma[Eenadu.vattu_TA_2]    = Padma.vattu_TA;
Eenadu.toPadma[Eenadu.vattu_THA]     = Padma.vattu_THA;
Eenadu.toPadma[Eenadu.vattu_DA]      = Padma.vattu_DA;
Eenadu.toPadma[Eenadu.vattu_DHA]     = Padma.vattu_DHA;
Eenadu.toPadma[Eenadu.vattu_NA]      = Padma.vattu_NA;
Eenadu.toPadma[Eenadu.vattu_PA]      = Padma.vattu_PA;
Eenadu.toPadma[Eenadu.vattu_PHA]     = Padma.vattu_PHA;
Eenadu.toPadma[Eenadu.vattu_BA]      = Padma.vattu_BA;
Eenadu.toPadma[Eenadu.vattu_BHA]     = Padma.vattu_BHA;
Eenadu.toPadma[Eenadu.vattu_MA]      = Padma.vattu_MA;
Eenadu.toPadma[Eenadu.vattu_YA]      = Padma.vattu_YA;
Eenadu.toPadma[Eenadu.vattu_RA_1]    = Padma.vattu_RA;
Eenadu.toPadma[Eenadu.vattu_RA_2]    = Padma.vattu_RA;
Eenadu.toPadma[Eenadu.vattu_LA]      = Padma.vattu_LA;
Eenadu.toPadma[Eenadu.vattu_VA]      = Padma.vattu_VA;
Eenadu.toPadma[Eenadu.vattu_SHA]     = Padma.vattu_SHA;
Eenadu.toPadma[Eenadu.vattu_SSA_1]   = Padma.vattu_SSA;
Eenadu.toPadma[Eenadu.vattu_SSA_2]   = Padma.vattu_SSA;
Eenadu.toPadma[Eenadu.vattu_SA]      = Padma.vattu_SA;
Eenadu.toPadma[Eenadu.vattu_HA]      = Padma.vattu_HA;
Eenadu.toPadma[Eenadu.vattu_LLA]     = Padma.vattu_LLA;
Eenadu.toPadma[Eenadu.vattu_RRA]     = Padma.vattu_RRA;

//Conjuncts
Eenadu.toPadma[Eenadu.vattu_TRA]     = Padma.vattu_TA + Padma.vattu_RA;
Eenadu.toPadma[Eenadu.vattu_TTRA]    = Padma.vattu_TTA + Padma.vattu_RA;

//Miscellaneous(where it doesn't match ASCII representation)
Eenadu.toPadma[Eenadu.extra_HYPHEN]   = Eenadu.HYPHEN;
Eenadu.toPadma[Eenadu.extra_QTSINGLE] = Eenadu.QTSINGLE;
Eenadu.toPadma[Eenadu.DIVIDE]         = "/";        //Should lookup Unicode standard for this and multiply
Eenadu.toPadma[Eenadu.MULTIPLY]       = "X";
Eenadu.toPadma[Eenadu.PIPE]           = "|";
Eenadu.toPadma[Eenadu.ASTERISK]       = "*";
Eenadu.toPadma[Eenadu.PERCENT]        = "%";

Eenadu.nonASCII = new Array();
Eenadu.nonASCII[Eenadu.DIVIDE]         = true;
Eenadu.nonASCII[Eenadu.MULTIPLY]       = true;
Eenadu.nonASCII[Eenadu.PIPE]           = true;
Eenadu.nonASCII[Eenadu.ASTERISK]       = true;
Eenadu.nonASCII[Eenadu.PERCENT]        = true;
Eenadu.nonASCII[Eenadu.extra_HYPHEN]   = true;
Eenadu.nonASCII[Eenadu.extra_QTSINGLE] = true;

Eenadu.redundantList = new Array();
Eenadu.redundantList[Eenadu.misc_TICK_1] = true;
Eenadu.redundantList[Eenadu.misc_TICK_2] = true;
Eenadu.redundantList[Eenadu.misc_TICK_3] = true;
Eenadu.redundantList[Eenadu.misc_TICK_4] = true;
Eenadu.redundantList[Eenadu.misc_TICK_5] = true;
Eenadu.redundantList[Eenadu.misc_TICK_6] = true;
Eenadu.redundantList[Eenadu.misc_TICK_7] = true;
Eenadu.redundantList[Eenadu.HYPHEN]      = true;

Eenadu.prefixList = new Array();
Eenadu.prefixList[Eenadu.vattu_RA_1]   = true;
Eenadu.prefixList[Eenadu.vattu_RA_2]   = true;
Eenadu.prefixList[Eenadu.vowelsn_E_2]  = true;
Eenadu.prefixList[Eenadu.vowelsn_E_4]  = true;
Eenadu.prefixList[Eenadu.vowelsn_EE_2] = true;
Eenadu.prefixList[Eenadu.vowelsn_EE_3] = true;

Eenadu.vowels = new Array();
Eenadu.vowels[Eenadu.vowel_A_1]     = true;
Eenadu.vowels[Eenadu.vowel_A_2]     = true;
Eenadu.vowels[Eenadu.vowel_AA]      = true;
Eenadu.vowels[Eenadu.vowel_I]       = true;
Eenadu.vowels[Eenadu.vowel_II]      = true;
Eenadu.vowels[Eenadu.vowel_U]       = true;
Eenadu.vowels[Eenadu.vowel_UU]      = true;
Eenadu.vowels[Eenadu.vowel_E]       = true;
Eenadu.vowels[Eenadu.vowel_EE]      = true;
Eenadu.vowels[Eenadu.vowel_AI]      = true;
Eenadu.vowels[Eenadu.vowel_O]       = true;
Eenadu.vowels[Eenadu.vowel_OO]      = true;
Eenadu.vowels[Eenadu.vowel_AU]      = true;
Eenadu.vowels[Eenadu.anusvara]      = true;

Eenadu.consonants = new Array();
Eenadu.consonants[Eenadu.consnt_KA_1]    = true;
Eenadu.consonants[Eenadu.consnt_KA_2]    = true;
Eenadu.consonants[Eenadu.consnt_KHA_1]   = true;
Eenadu.consonants[Eenadu.consnt_KHA_2]   = true;
Eenadu.consonants[Eenadu.consnt_GA]      = true;
Eenadu.consonants[Eenadu.consnt_GHA]     = true;
Eenadu.consonants[Eenadu.consnt_NGA]     = true;
Eenadu.consonants[Eenadu.consnt_CA]      = true;
Eenadu.consonants[Eenadu.consnt_CHA]     = true;
Eenadu.consonants[Eenadu.consnt_JA_1]    = true;
Eenadu.consonants[Eenadu.consnt_JA_2]    = true;
Eenadu.consonants[Eenadu.consnt_JHA]     = true;
Eenadu.consonants[Eenadu.consnt_NYA]     = true;
Eenadu.consonants[Eenadu.consnt_TTA_1]   = true;
Eenadu.consonants[Eenadu.consnt_TTA_2]   = true;
Eenadu.consonants[Eenadu.consnt_TTA_3]   = true;
Eenadu.consonants[Eenadu.consnt_TTHA]    = true;
Eenadu.consonants[Eenadu.consnt_DDA]     = true;
Eenadu.consonants[Eenadu.consnt_DDHA]    = true;
Eenadu.consonants[Eenadu.consnt_NNA]     = true;
Eenadu.consonants[Eenadu.consnt_TA]      = true;
Eenadu.consonants[Eenadu.consnt_DA]      = true;
Eenadu.consonants[Eenadu.consnt_DHA_1]   = true;
Eenadu.consonants[Eenadu.consnt_DHA_2]   = true;
Eenadu.consonants[Eenadu.consnt_NA_1]    = true;
Eenadu.consonants[Eenadu.consnt_NA_2]    = true;
Eenadu.consonants[Eenadu.consnt_NA_3]    = true;
Eenadu.consonants[Eenadu.consnt_PA_1]    = true;
Eenadu.consonants[Eenadu.consnt_PA_2]    = true;
Eenadu.consonants[Eenadu.consnt_PHA_1]   = true;
Eenadu.consonants[Eenadu.consnt_PHA_2]   = true;
Eenadu.consonants[Eenadu.consnt_BA_1]    = true;
Eenadu.consonants[Eenadu.consnt_BA_2]    = true;
Eenadu.consonants[Eenadu.consnt_BHA]     = true;
Eenadu.consonants[Eenadu.consnt_MA]      = true;
Eenadu.consonants[Eenadu.consnt_YA_1]    = true;
Eenadu.consonants[Eenadu.consnt_YA_2]    = true;
Eenadu.consonants[Eenadu.consnt_RA]      = true;
Eenadu.consonants[Eenadu.consnt_LA_1]    = true;
Eenadu.consonants[Eenadu.consnt_LA_2]    = true;
Eenadu.consonants[Eenadu.consnt_VA_1]    = true;
Eenadu.consonants[Eenadu.consnt_VA_2]    = true;
Eenadu.consonants[Eenadu.consnt_SHA]     = true;
Eenadu.consonants[Eenadu.consnt_SSA_1]   = true;
Eenadu.consonants[Eenadu.consnt_SSA_2]   = true;
Eenadu.consonants[Eenadu.consnt_SA_1]    = true;
Eenadu.consonants[Eenadu.consnt_SA_2]    = true;
Eenadu.consonants[Eenadu.consnt_HA]      = true;
Eenadu.consonants[Eenadu.consnt_LLA]     = true;
Eenadu.consonants[Eenadu.consnt_RRA]     = true;
Eenadu.consonants[Eenadu.consnt_KSHA]    = true;

Eenadu.specials = new Array();
Eenadu.specials[Eenadu.candrabindu]    = true;
Eenadu.specials[Eenadu.visarga]        = true;
Eenadu.specials[Eenadu.virama_1]       = true;
Eenadu.specials[Eenadu.virama_2]       = true;
Eenadu.specials[Eenadu.virama_3]       = true;
Eenadu.specials[Eenadu.virama_4]       = true;
Eenadu.specials[Eenadu.virama_5]       = true;
Eenadu.specials[Eenadu.virama_6]       = true;

Eenadu.specialValues = new Array();
Eenadu.specialValues[Padma.candrabindu]  = true;
Eenadu.specialValues[Padma.visarga]      = true;
Eenadu.specialValues[Padma.pollu]        = true;
Eenadu.specialValues[Padma.anusvara]     = true;
Eenadu.specialValues[Padma.vowelsn_AA]   = true;
Eenadu.specialValues[Padma.vowelsn_I]    = true;
Eenadu.specialValues[Padma.vowelsn_II]   = true;
Eenadu.specialValues[Padma.vowelsn_U]    = true;
Eenadu.specialValues[Padma.vowelsn_UU]   = true;
Eenadu.specialValues[Padma.vowelsn_R]    = true;
Eenadu.specialValues[Padma.vowelsn_RR]   = true;
Eenadu.specialValues[Padma.vowelsn_L]    = true;
Eenadu.specialValues[Padma.vowelsn_LL]   = true;
Eenadu.specialValues[Padma.vowelsn_E]    = true;
Eenadu.specialValues[Padma.vowelsn_EE]   = true;
Eenadu.specialValues[Padma.vowelsn_AI]   = true;
Eenadu.specialValues[Padma.vowelsn_O]    = true;
Eenadu.specialValues[Padma.vowelsn_OO]   = true;
Eenadu.specialValues[Padma.vowelsn_AU]   = true;
Eenadu.specialValues[Padma.vowelsn_AILEN]= true;

Eenadu.combos = new Array();
Eenadu.combos[Eenadu.combo_KHI]      = true;
Eenadu.combos[Eenadu.combo_KHII]     = true;
Eenadu.combos[Eenadu.combo_GI]       = true;
Eenadu.combos[Eenadu.combo_GII]      = true;
Eenadu.combos[Eenadu.combo_GHAA]     = true;
Eenadu.combos[Eenadu.combo_GHI]      = true;
Eenadu.combos[Eenadu.combo_CI]       = true;
Eenadu.combos[Eenadu.combo_CII]      = true;
Eenadu.combos[Eenadu.combo_JI]       = true;
Eenadu.combos[Eenadu.combo_JII]      = true;
Eenadu.combos[Eenadu.combo_JU]       = true;
Eenadu.combos[Eenadu.combo_JUU]      = true;
Eenadu.combos[Eenadu.combo_TI]       = true;
Eenadu.combos[Eenadu.combo_TII]      = true;
Eenadu.combos[Eenadu.combo_DI]       = true;
Eenadu.combos[Eenadu.combo_DII]      = true;
Eenadu.combos[Eenadu.combo_DHI_1]    = true;
Eenadu.combos[Eenadu.combo_DHI_2]    = true;
Eenadu.combos[Eenadu.combo_DHII]     = true;
Eenadu.combos[Eenadu.combo_NI]       = true;
Eenadu.combos[Eenadu.combo_NII]      = true;
Eenadu.combos[Eenadu.combo_BI]       = true;
Eenadu.combos[Eenadu.combo_BII]      = true;
Eenadu.combos[Eenadu.combo_BHI]      = true;
Eenadu.combos[Eenadu.combo_BHII]     = true;
Eenadu.combos[Eenadu.combo_MAA]      = true;
Eenadu.combos[Eenadu.combo_MI]       = true;
Eenadu.combos[Eenadu.combo_MII]      = true;
Eenadu.combos[Eenadu.combo_MU]       = true;
Eenadu.combos[Eenadu.combo_MUU]      = true;
Eenadu.combos[Eenadu.combo_ME_1]     = true;
Eenadu.combos[Eenadu.combo_ME_2]     = true;
Eenadu.combos[Eenadu.combo_MEE]      = true;
Eenadu.combos[Eenadu.combo_MAI]      = true;
Eenadu.combos[Eenadu.combo_MO]       = true;
Eenadu.combos[Eenadu.combo_MOO]      = true;
Eenadu.combos[Eenadu.combo_MPOLLU]   = true;
Eenadu.combos[Eenadu.combo_YAA]      = true;
Eenadu.combos[Eenadu.combo_YI]       = true;
Eenadu.combos[Eenadu.combo_YE]       = true;
Eenadu.combos[Eenadu.combo_YEE]      = true;
Eenadu.combos[Eenadu.combo_YO]       = true;
Eenadu.combos[Eenadu.combo_YOO]      = true;
Eenadu.combos[Eenadu.combo_YPOLLU_1] = true;
Eenadu.combos[Eenadu.combo_YPOLLU_2] = true;
Eenadu.combos[Eenadu.combo_RI]       = true;
Eenadu.combos[Eenadu.combo_RII]      = true;
Eenadu.combos[Eenadu.combo_LI]       = true;
Eenadu.combos[Eenadu.combo_LII]      = true;
Eenadu.combos[Eenadu.combo_VI]       = true;
Eenadu.combos[Eenadu.combo_VII]      = true;
Eenadu.combos[Eenadu.combo_SHI]      = true;
Eenadu.combos[Eenadu.combo_SHII]     = true;
Eenadu.combos[Eenadu.combo_LLI]      = true;
Eenadu.combos[Eenadu.combo_LLII]     = true;
Eenadu.combos[Eenadu.combo_SHRII]    = true;


Eenadu.lookup = function (str, ctxt) 
{
    if (ctxt == Eenadu.ctxt_REGULAR || (ctxt == Eenadu.ctxt_HA && str != Eenadu.vowelsn_AA_3))
        return Eenadu.toPadma[str];
    else return "";
}

Eenadu.isRedundant = function (str)
{
    return Eenadu.redundantList[str] != null;
}

Eenadu.isPrefixSymbol = function (str)
{
    return Eenadu.prefixList[str] != null;
}

Eenadu.isVowel = function (str)
{
    return Eenadu.vowels[str] != null;
}

Eenadu.isConsonant = function (str)
{
    return Eenadu.consonants[str] != null;
}

Eenadu.isSpecial = function (str)
{
    return Eenadu.specials[str] != null;
}

Eenadu.isComboSymbol = function (str)
{
    return Eenadu.combos[str] != null;
}

Eenadu.isSpecialValue = function (str)
{
    return Eenadu.specialValues[str] != null;
}

Eenadu.isNonASCII = function (str)
{
    return Eenadu.nonASCII[str] != null;
}

Eenadu.isSyllableStart = function (str) 
{
    return Eenadu.isVowel(str) || Eenadu.isConsonant(str) || Eenadu.isPrefixSymbol(str) || Eenadu.isComboSymbol(str) ||
           Eenadu.isNonASCII(str);
}

//\u00C7 is used mostly for AA gunintam - unfortunately it is also used for writing HA, so it needs to be handled specially
Eenadu.getContext = function (str)
{
    if (str == Eenadu.consnt_HA)
        return Eenadu.ctxt_HA;
    else return Eenadu.ctxt_REGULAR;
}
