// $Id: UnicodeParser.js,v 1.1.2.3 2005/06/16 22:49:43 vnagarjuna Exp $ -->

/* ***** BEGIN LICENSE BLOCK ***** 
 * Version: MPL 1.1/GPL 2.0/LGPL 2.1
 *
 * The contents of this file are subject to the Mozilla Public License Version
 * 1.1 (the "License"); you may not use this file except in compliance with
 * the License. You may obtain a copy of the License at
 * http://www.mozilla.org/MPL/
 *
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
 * for the specific language governing rights and limitations under the
 * License.
 *
 * The Initial Developer of the Original Code is Nagarjuna Venna.
 * Portions created by the Initial Developer are Copyright (C) 2005
 * by the Initial Developer. All Rights Reserved.
 *
 * Contributor(s): Nagarjuna Venna <vnagarjuna@yahoo.com>
 *
 * Alternatively, the contents of this file may be used under the terms of
 * either the GNU General Public License Version 2 or later (the "GPL"), or
 * the GNU Lesser General Public License Version 2.1 or later (the "LGPL"),
 * in which case the provisions of the GPL or the LGPL are applicable instead
 * of those above. If you wish to allow use of your version of this file only
 * under the terms of either the GPL or the LGPL, and not to allow others to
 * use your version of this file under the terms of the MPL, indicate your
 * decision by deleting the provisions above and replace them with the notice
 * and other provisions required by the GPL or the LGPL. If you do not delete
 * the provisions above, a recipient may use your version of this file under
 * the terms of any one of the MPL, the GPL or the LGPL.
 *
 * ***** END LICENSE BLOCK ***** */

//Parser for RTS Text - returns syllables

function UnicodeParser(input) {
    this.index = 0;
    this.length = input.length;
    this.text = input;
}

function UnicodeParser_next()
{
    var response = "";

    var remaining = this.length - this.index;
    for(; remaining > 0; remaining = this.length - this.index) {
        var maxLookupLen = remaining > Unicode.maxLookupLen ? Unicode.maxLookupLen : remaining;
        
        var key, value;
        for(var i = maxLookupLen; i > 0; i--) {
            key = this.text.substring(this.index, this.index + i);
            //alert("looking up " + key);
            value = Unicode.lookup(key);
            if (value != null) {
                break;
            }
        }

        response = this.handleInput(value, key, response);
        if (this.state == Parser.state_START)
            return response;
    }

    return response.length != 0 ? response : null;
}

